import scriptcontext as sc
import Rhino.DocObjects

for layer in sc.doc.Layers:
    objs = list(filter(lambda obj : obj.Attributes.LayerIndex == layer.LayerIndex and obj.Attributes.MaterialSource == Rhino.DocObjects.ObjectMaterialSource.MaterialFromLayer, sc.doc.Objects))
    for o in objs:
        o.Attributes.MaterialSource = Rhino.DocObjects.ObjectMaterialSource.MaterialFromObject
        o.Attributes.MaterialIndex = layer.RenderMaterialIndex
        o.CommitChanges()

sc.doc.Views.Redraw()